package 
{
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.desktop.Clipboard;
	import flash.desktop.ClipboardFormats;
	
	import qwazlab.geom.Face;
	
	import com.bit101.components.InputText;
	import com.bit101.components.PushButton;
	import com.bit101.components.ComboBox;
	import com.bit101.components.Style;

	/**
	 * ...
	 * @author Qwaz
	 */
	[Frame(factoryClass = "Preloader")]
	[SWF (width="500", height="500")]
	public class Main extends Sprite 
	{
		public const p4:String = '4/1,2,3/2,5,4/3,4,6/5,1,6';
		public const p6:String = '6/1,4,3,2/3,9,8,7/2,7,6,5/1,5,12,11/9,4,11,10/6,8,10,12';
		public const p8:String = '8/1,2,3/1,9,4/2,5,6/3,7,8/6,11,7/9,8,12/4,10,5/10,12,11';
		public const p12:String = '12/1,2,3,4,5/1,10,19,20,6/2,6,11,12,7/3,7,13,14,8/4,8,15,16,9/5,9,17,18,10/20,25,26,21,11/12,21,27,22,13/14,22,28,23,15/16,23,29,24,17/18,24,30,25,19/26,30,29,28,27';
		public const p20:String = '20/1,2,3/1,9,10/2,4,5/3,6,7/10,18,11/4,11,12/5,13,14/6,14,15/8,7,16/9,8,17/12,19,20/13,20,21/23,15,22/16,23,24/26,17,25/26,27,18/27,28,19/21,29,22/25,24,30/28,30,29';
		public const p6_8:String = '14/1,2,3/1,8,15,9/2,4,11,5/3,6,13,7/9,10,4/5,12,6/8,7,14/15,20,21/11,16,17/13,18,19/10,21,22,16/12,17,23,18/14,19,24,20/22,24,23';
		
		public var myParser:Parser;
		
		public var canvas:Sprite;
		
		public var radiusInput:InputText;
		public var dataInput:InputText;
		public var generateBtn:PushButton;
		public var copyComboBox:ComboBox;
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}

		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			Face.beginFill(0xFFFFFF);
			Face.lineStyle(1, 0, 1, false, "none");
			
			Style.setStyle(Style.LIGHT);
			
			myParser = new Parser();
			
			radiusInput = new InputText(this, 5, 5, "30");
			radiusInput.width = 30;
			radiusInput.restrict = '0-9';
			dataInput = new InputText(this, 5, radiusInput.y + radiusInput.height + 5);
			dataInput.width = 490;
			generateBtn = new PushButton(this, radiusInput.x + radiusInput.width + 5, 5, "Draw", drawHandler);
			generateBtn.width = 50;
			generateBtn.height = radiusInput.height;
			copyComboBox = new ComboBox(this, generateBtn.x + generateBtn.width + 5, 5, "", ["Tetrahedron", "Cube", "Octahedron", "Dodecahedron", "Icosahedron", "Cuboctahedron"]);
			copyComboBox.height = radiusInput.height;
			copyComboBox.addEventListener(Event.SELECT, copyData);
			copyComboBox.selectedIndex = 0;
			copyComboBox.numVisibleItems = 6;
		}
		
		private function copyData(e:Event):void {
			var now:int = copyComboBox.selectedIndex;
			
			switch(now) {
				case 0:
					Clipboard.generalClipboard.setData(ClipboardFormats.TEXT_FORMAT, p4);
					dataInput.text = p4;
					break;
				case 1:
					Clipboard.generalClipboard.setData(ClipboardFormats.TEXT_FORMAT, p6);
					dataInput.text = p6;
					break;
				case 2:
					Clipboard.generalClipboard.setData(ClipboardFormats.TEXT_FORMAT, p8);
					dataInput.text = p8;
					break;
				case 3:
					Clipboard.generalClipboard.setData(ClipboardFormats.TEXT_FORMAT, p12);
					dataInput.text = p12;
					break;
				case 4:
					Clipboard.generalClipboard.setData(ClipboardFormats.TEXT_FORMAT, p20);
					dataInput.text = p20;
					break;
				case 5:
					Clipboard.generalClipboard.setData(ClipboardFormats.TEXT_FORMAT, p6_8);
					dataInput.text = p6_8;
					break;
			}
		}
		
		private function drawHandler(e:MouseEvent):void {
			var face:Face;
			
			if (canvas == null) {
				canvas = new Sprite();
				this.addChild(canvas);
				canvas.x = stage.stageWidth / 2;
				canvas.y = stage.stageHeight / 2;
			} else {
				for each (face in myParser.faceArr) {
					canvas.removeChild(face);
				}
			}
			
			myParser.radius = Number(radiusInput.text);
			myParser.parse(dataInput.text, canvas);
		}
	}
}