package 
{
	import flash.display.DisplayObjectContainer;
	import flash.utils.Dictionary;
	import qwazlab.geom.Edge;
	import qwazlab.geom.Face;
	
	/**
	 * ...
	 * @author Qwaz
	 */
	public class Parser
	{
		private var _edgeArr:Array;
		private var _faceArr:Vector.<Face>;
		private var _array:Array;
		
		private var sNum:int;
		
		public var radius:Number = 20;
		
		public function parse (data:String, canvas:DisplayObjectContainer):void {
			var fClone:Vector.<Face> = new Vector.<Face>;
			
			_array = data.split('/');
			var length:int = int(_array[0]);
			
			var i:int;
			var j:int;
			for (i = 1; i <= length; i++) {
				_array[i] = String(_array[i]).split(',');
			}
			
			_faceArr = new Vector.<Face>;
			_edgeArr = new Array();
			
			for (i = 1; i <= length; i++) {
				_faceArr.push(Face.makeRegularPolygon(_array[i].length, radius));
				fClone.push(_faceArr[i - 1]);
				canvas.addChild(_faceArr[i - 1]);
			}
			
			var start:int = Math.floor(Math.random() * length);
			
			start = Math.floor(Math.random() * length);
			
			process(_faceArr[start]);
			while(_edgeArr.length > 0) {
				_edgeArr.sort(randomSort);
				_edgeArr.sort(randomSort);
				for (i = 1; i < _array.length; i++) {
					for (j = 0; j < _array[i].length; j++) {
						if (_array[i][j] == _edgeArr[0][1]) {
							_faceArr[i - 1].attachToOtherFace(_faceArr[i - 1].edges[j], _edgeArr[0][0]);
							process(_faceArr[i - 1]);
							break;
						}
					}
				}
			}
			
			var face:Face;
			for each (face in fClone) {
				_faceArr.push(face);
			}
		}
		
		private function process(target:Face):void {
			var index:int = _faceArr.indexOf(target);
			
			var i:int;
			var j:int;
			var chk:Boolean;
			for (i = 0; i < target.edges.length; i++) {
				chk = false;
				for (j = 0; j < _edgeArr.length; j++) {
					if (_array[index + 1][i] == _edgeArr[j][1]) {
						target.edges[i].linked = _edgeArr[j][0];
						_edgeArr[j][0].linked = target.edges[i];
						_edgeArr.splice(j, 1);
						chk = true;
						break;
					}
				}
				if (!chk) {
					_edgeArr.push([target.edges[i], _array[index + 1][i]]);
				}
			}
			_faceArr.splice(index, 1);
			_array.splice(index + 1, 1);
		}
		
		private function randomSort(x:Object, y:Object):int {
			if (Math.random() < 0.5) {
				return -1;
			}
			return 1;
		}
		
		public function get faceArr():Vector.<Face> {
			return _faceArr;
		}
	}
	
}