package 
{
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.text.TextFieldAutoSize;
	import flash.utils.getDefinitionByName;
	
	import com.bit101.components.Label;
	
	/**
	 * ...
	 * @author Qwaz
	 */
	public class Preloader extends MovieClip 
	{
		private var loader:Shape;
		private var label:Label;
		private const LOADER_WIDTH:Number = 100;
		private const LOADER_HEIGHT:Number = 10;
		
		public function Preloader() 
		{
			if (stage) {
				stage.scaleMode = StageScaleMode.NO_SCALE;
				stage.align = StageAlign.TOP_LEFT;
			}
			addEventListener(Event.ENTER_FRAME, checkFrame);
			loaderInfo.addEventListener(ProgressEvent.PROGRESS, progress);
			loaderInfo.addEventListener(IOErrorEvent.IO_ERROR, ioError);
			
			loader = addChild(new Shape()) as Shape;
			label = addChild(new Label(this, stage.stageWidth / 2, stage.stageHeight / 2)) as Label;
			label.autoSize = true;
		}
		
		private function ioError(e:IOErrorEvent):void 
		{
			trace(e.text);
		}
		
		private function progress(e:ProgressEvent):void 
		{
			with (loader.graphics) {
				clear();
				lineStyle(3, 0);
				beginFill(0xFFFFFF);
				moveTo(stage.stageWidth / 2 - LOADER_WIDTH / 2, stage.stageHeight / 2 - LOADER_HEIGHT / 2);
				lineTo(stage.stageWidth / 2 + LOADER_WIDTH / 2, stage.stageHeight / 2 - LOADER_HEIGHT / 2);
				lineTo(stage.stageWidth / 2 + LOADER_WIDTH / 2, stage.stageHeight / 2 + LOADER_HEIGHT / 2);
				lineTo(stage.stageWidth / 2 - LOADER_WIDTH / 2, stage.stageHeight / 2 + LOADER_HEIGHT / 2);
				lineTo(stage.stageWidth / 2 - LOADER_WIDTH / 2, stage.stageHeight / 2 - LOADER_HEIGHT / 2);
				
				lineStyle(0);
				beginFill(0x2BCD37);
				moveTo(stage.stageWidth / 2 - LOADER_WIDTH / 2, stage.stageHeight / 2 - LOADER_HEIGHT / 2);
				lineTo(stage.stageWidth / 2 - LOADER_WIDTH / 2 + LOADER_WIDTH * e.bytesLoaded / e.bytesTotal, stage.stageHeight  / 2 - LOADER_HEIGHT / 2);
				lineTo(stage.stageWidth / 2 - LOADER_WIDTH / 2 + LOADER_WIDTH * e.bytesLoaded / e.bytesTotal, stage.stageHeight  / 2 + LOADER_HEIGHT / 2);
				lineTo(stage.stageWidth / 2 - LOADER_WIDTH / 2, stage.stageHeight / 2 + LOADER_HEIGHT / 2);
				lineTo(stage.stageWidth / 2 - LOADER_WIDTH / 2, stage.stageHeight / 2 - LOADER_HEIGHT / 2);
			}
			
			label.text = String(int(e.bytesLoaded / e.bytesTotal * 100)) + "%";
			label.x = stage.stageWidth - 30;
			label.y = stage.stageHeight - 18;
		}
		
		private function checkFrame(e:Event):void 
		{
			if (currentFrame == totalFrames) 
			{
				stop();
				loadingFinished();
			}
		}
		
		private function loadingFinished():void 
		{
			removeEventListener(Event.ENTER_FRAME, checkFrame);
			loaderInfo.removeEventListener(ProgressEvent.PROGRESS, progress);
			loaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, ioError);
			
			loader.graphics.clear();
			removeChild(loader);
			
			removeChild(label);
			
			startup();
		}
		
		private function startup():void 
		{
			var mainClass:Class = getDefinitionByName("Main") as Class;
			addChild(new mainClass() as DisplayObject);
		}
		
	}
	
}